/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"time"
)

// checks if the GroupScope type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupScope{}

// GroupScope struct for GroupScope
type GroupScope struct {
	DisplayName          string         `json:"displayName"`
	GroupScopeIdentifier string         `json:"groupScopeIdentifier"`
	Id                   NullableString `json:"id,omitempty"`
	CreationTime         *time.Time     `json:"creationTime,omitempty"`
}

type _GroupScope GroupScope

// NewGroupScope instantiates a new GroupScope object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupScope(displayName string, groupScopeIdentifier string) *GroupScope {
	this := GroupScope{}
	this.DisplayName = displayName
	this.GroupScopeIdentifier = groupScopeIdentifier
	return &this
}

// NewGroupScopeWithDefaults instantiates a new GroupScope object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupScopeWithDefaults() *GroupScope {
	this := GroupScope{}
	return &this
}

// GetDisplayName returns the DisplayName field value
func (o *GroupScope) GetDisplayName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DisplayName
}

// GetDisplayNameOk returns a tuple with the DisplayName field value
// and a boolean to check if the value has been set.
func (o *GroupScope) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DisplayName, true
}

// SetDisplayName sets field value
func (o *GroupScope) SetDisplayName(v string) {
	o.DisplayName = v
}

// GetGroupScopeIdentifier returns the GroupScopeIdentifier field value
func (o *GroupScope) GetGroupScopeIdentifier() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GroupScopeIdentifier
}

// GetGroupScopeIdentifierOk returns a tuple with the GroupScopeIdentifier field value
// and a boolean to check if the value has been set.
func (o *GroupScope) GetGroupScopeIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GroupScopeIdentifier, true
}

// SetGroupScopeIdentifier sets field value
func (o *GroupScope) SetGroupScopeIdentifier(v string) {
	o.GroupScopeIdentifier = v
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupScope) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupScope) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *GroupScope) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *GroupScope) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *GroupScope) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *GroupScope) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *GroupScope) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupScope) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *GroupScope) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *GroupScope) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o GroupScope) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupScope) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["displayName"] = o.DisplayName
	toSerialize["groupScopeIdentifier"] = o.GroupScopeIdentifier
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

func (o *GroupScope) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"displayName",
		"groupScopeIdentifier",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varGroupScope := _GroupScope{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varGroupScope)

	if err != nil {
		return err
	}

	*o = GroupScope(varGroupScope)

	return err
}

type NullableGroupScope struct {
	value *GroupScope
	isSet bool
}

func (v NullableGroupScope) Get() *GroupScope {
	return v.value
}

func (v *NullableGroupScope) Set(val *GroupScope) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupScope) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupScope) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupScope(val *GroupScope) *NullableGroupScope {
	return &NullableGroupScope{value: val, isSet: true}
}

func (v NullableGroupScope) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupScope) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
